package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFActor;
import com.sa.ibiz.demo.demo.domain.WFStep;

/**
 * 实体[WFTmpStepActor] 数据对象
 */
@TableName(value = "T_SRFWFTMPSTEPACTOR",resultMap = "WFTmpStepActorResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFTmpStepActor extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFActor wfactor;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFStep wfstep;
    private String connection;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    private String prevprocess;
    private String prevwfstepid;
    private String prevwfstepname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String wfactorid;
    private String wfactorname;
    @TableId(value= "wftmpstepactorid",type=IdType.UUID)//指定主键生成策略
    private String wftmpstepactorid;
    private String wftmpstepactorname;
    /**
     *  设置属性值[操作连接]
     *  @param connection
     */
    public void setConnection(String connection){
        if(StringUtils.isEmpty(connection))
            connection=null;
        this.connection = connection;
        this.set("connectiondirtyflag",true);
    }
    /**
     *  获取属性值[操作连接]
     */
    public String getConnection(){
        return this.connection;
    }
    /**
     *  重置属性值[操作连接]
     */
    public void resetConnection(){
        this.set("connectiondirtyflag",false);
        this.connection = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[上一个处理]
     *  @param prevprocess
     */
    public void setPrevprocess(String prevprocess){
        if(StringUtils.isEmpty(prevprocess))
            prevprocess=null;
        this.prevprocess = prevprocess;
        this.set("prevprocessdirtyflag",true);
    }
    /**
     *  获取属性值[上一个处理]
     */
    public String getPrevprocess(){
        return this.prevprocess;
    }
    /**
     *  重置属性值[上一个处理]
     */
    public void resetPrevprocess(){
        this.set("prevprocessdirtyflag",false);
        this.prevprocess = null;
    }
    /**
     *  设置属性值[工作流临时步骤操作者（上一步骤）]
     *  @param prevwfstepid
     */
    public void setPrevwfstepid(String prevwfstepid){
        if(StringUtils.isEmpty(prevwfstepid))
            prevwfstepid=null;
        this.prevwfstepid = prevwfstepid;
        this.set("prevwfstepiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流临时步骤操作者（上一步骤）]
     */
    public String getPrevwfstepid(){
        return this.prevwfstepid;
    }
    /**
     *  重置属性值[工作流临时步骤操作者（上一步骤）]
     */
    public void resetPrevwfstepid(){
        this.set("prevwfstepiddirtyflag",false);
        this.prevwfstepid = null;
    }
    /**
     *  设置属性值[工作流临时步骤操作者（上一步骤）]
     *  @param prevwfstepname
     */
    public void setPrevwfstepname(String prevwfstepname){
        if(StringUtils.isEmpty(prevwfstepname))
            prevwfstepname=null;
        this.prevwfstepname = prevwfstepname;
        this.set("prevwfstepnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流临时步骤操作者（上一步骤）]
     */
    public String getPrevwfstepname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.prevwfstepname)&&(!StringUtils.isEmpty(this.getPrevwfstepid())) && this.getWfstep()!=null)
        {
            this.prevwfstepname = this.getWfstep().getWfplogicname();
            this.set("prevwfstepnamedirtyflag",true);
        }
        return this.prevwfstepname;
    }
    /**
     *  重置属性值[工作流临时步骤操作者（上一步骤）]
     */
    public void resetPrevwfstepname(){
        this.set("prevwfstepnamedirtyflag",false);
        this.prevwfstepname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流临时步骤操作者_工作流操作者]
     *  @param wfactorid
     */
    public void setWfactorid(String wfactorid){
        if(StringUtils.isEmpty(wfactorid))
            wfactorid=null;
        this.wfactorid = wfactorid;
        this.set("wfactoriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流临时步骤操作者_工作流操作者]
     */
    public String getWfactorid(){
        return this.wfactorid;
    }
    /**
     *  重置属性值[工作流临时步骤操作者_工作流操作者]
     */
    public void resetWfactorid(){
        this.set("wfactoriddirtyflag",false);
        this.wfactorid = null;
    }
    /**
     *  设置属性值[工作流临时步骤操作者_工作流操作者]
     *  @param wfactorname
     */
    public void setWfactorname(String wfactorname){
        if(StringUtils.isEmpty(wfactorname))
            wfactorname=null;
        this.wfactorname = wfactorname;
        this.set("wfactornamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流临时步骤操作者_工作流操作者]
     */
    public String getWfactorname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.wfactorname)&&(!StringUtils.isEmpty(this.getWfactorid())) && this.getWfactor()!=null)
        {
            this.wfactorname = this.getWfactor().getWfactorname();
            this.set("wfactornamedirtyflag",true);
        }
        return this.wfactorname;
    }
    /**
     *  重置属性值[工作流临时步骤操作者_工作流操作者]
     */
    public void resetWfactorname(){
        this.set("wfactornamedirtyflag",false);
        this.wfactorname = null;
    }
    /**
     *  设置属性值[工作流步骤操作者（临时）标识]
     *  @param wftmpstepactorid
     */
    public void setWftmpstepactorid(String wftmpstepactorid){
        if(StringUtils.isEmpty(wftmpstepactorid))
            wftmpstepactorid=null;
        this.wftmpstepactorid = wftmpstepactorid;
        this.set("wftmpstepactoriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流步骤操作者（临时）标识]
     */
    public String getWftmpstepactorid(){
        return this.wftmpstepactorid;
    }
    /**
     *  重置属性值[工作流步骤操作者（临时）标识]
     */
    public void resetWftmpstepactorid(){
        this.set("wftmpstepactoriddirtyflag",false);
        this.wftmpstepactorid = null;
    }
    /**
     *  设置属性值[工作流步骤操作者（临时）名称]
     *  @param wftmpstepactorname
     */
    public void setWftmpstepactorname(String wftmpstepactorname){
        if(StringUtils.isEmpty(wftmpstepactorname))
            wftmpstepactorname=null;
        this.wftmpstepactorname = wftmpstepactorname;
        this.set("wftmpstepactornamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流步骤操作者（临时）名称]
     */
    public String getWftmpstepactorname(){
        return this.wftmpstepactorname;
    }
    /**
     *  重置属性值[工作流步骤操作者（临时）名称]
     */
    public void resetWftmpstepactorname(){
        this.set("wftmpstepactornamedirtyflag",false);
        this.wftmpstepactorname = null;
    }
     /**
     *  获取主实体关联数据[WFActor]
     */
    public WFActor getWfactor() {
        return wfactor;
    }
    /**
     *  设置主实体关联数据[WFActor]
     */
    public void setWfactor(WFActor wfactor) {
        this.wfactor = wfactor;
    }

     /**
     *  获取主实体关联数据[WFStep]
     */
    public WFStep getWfstep() {
        return wfstep;
    }
    /**
     *  设置主实体关联数据[WFStep]
     */
    public void setWfstep(WFStep wfstep) {
        this.wfstep = wfstep;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetConnection();
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetPrevprocess();
        resetPrevwfstepid();
        resetPrevwfstepname();
        resetUpdatedate();
        resetUpdateman();
        resetWfactorid();
        resetWfactorname();
        resetWftmpstepactorid();
        resetWftmpstepactorname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFTmpStepActor copyTo(WFTmpStepActor targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFTmpStepActor.class, WFTmpStepActor.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWftmpstepactorid();
		return targetEntity;
	}
}